%define build_doc 0
%{?_without_doc: %global build_doc 0}
%{?_with_doc: %global build_doc 1}

%define major 1
%define libname %mklibname nutscan %{major}
%define libups %mklibname upsclient %{major}
%define libnut %mklibname nutclient %{major}

%define nutuser ups

Summary:	Network UPS Tools Client Utilities
Name:		nut
Version:	2.7.1
Release:	5
Epoch:		1
License:	GPLv2+
Group:		System/Configuration/Hardware
Url:		http://www.networkupstools.org/
Source0:	http://www.networkupstools.org/source/2.7/%{name}-%{version}.tar.gz
Source1:	http://www.networkupstools.org/source/2.7/%{name}-%{version}.tar.gz.sig
Source100:	ups.conf
Source101:	upsd.users
Source102:	70-nut-usbups.rules
Source103:	nut.tmpfiles.d
Patch0:		nut-upsset.conf.diff
Patch1:		nut-mdv_conf.diff
Patch2:         backport-fix-lp753661.patch
Patch3:         link-fixes.patch
Patch4:         configure.patch
Patch5:		nut-server.service.patch
Patch6:		upsmon_config.patch


%if %{build_doc}
BuildRequires:	asciidoc
BuildRequires:	dblatex
%endif
BuildRequires:	libtool
BuildRequires:	systemd-units
BuildRequires:	genders-devel
BuildRequires:	jpeg-devel
BuildRequires:	libgd-devel
BuildRequires:	libtool-devel
BuildRequires:	net-snmp-devel
BuildRequires:	tcp_wrappers-devel
BuildRequires:	pkgconfig(freetype2)
BuildRequires:	pkgconfig(libpng)
BuildRequires:	pkgconfig(libpowerman)
BuildRequires:	pkgconfig(libsystemd-daemon)
BuildRequires:	pkgconfig(libusb)
BuildRequires:	pkgconfig(neon)
BuildRequires:	pkgconfig(openssl)
BuildRequires:	pkgconfig(xpm)

Requires(pre):	rpm-helper
Requires(post):	rpm-helper systemd
Requires(postun): rpm-helper systemd
Requires(preun): rpm-helper systemd

%description
These programs are part of a developing project to monitor the assortment of
UPSes that are found out there in the field. Many models have serial ports of
some kind that allow some form of state checking. This capability has been
harnessed where possible to allow for safe shutdowns, live status tracking on
web pages, and more.

This package includes the client utilities that are required to monitor a UPS
that the client host is powered from - either connected directly via a serial
port (in which case the nut-server package needs to be installed on this
machine) or across the network (where another host on the network monitors the
UPS via serial cable and runs the main nut package to allow clients to see the
information).

%files
%doc AUTHORS COPYING ChangeLog MAINTAINERS NEWS README UPGRADING docs
%{_unitdir}/nut-monitor.service
%attr(0755,root,root) %dir %{_sysconfdir}/ups
%attr(0640,root,%{nutuser}) %config(noreplace) %{_sysconfdir}/ups/upssched.conf
%attr(0640,root,%{nutuser}) %{_sysconfdir}/ups/upsmon.conf.sample
%attr(0640,root,root) %{_sysconfdir}/ups/upsmon.conf
%attr(0750,%{nutuser},%{nutuser}) %dir /var/state/ups
#%attr(0755,%{nutuser},%{nutuser}) %dir /var/run/nut
%{_prefix}/lib/tmpfiles.d/%{name}.conf
%{_bindir}/nut-scanner
%{_bindir}/upsc
%{_bindir}/upscmd
%{_bindir}/upslog
%{_bindir}/upsrw
%{_bindir}/upssched-cmd
%{_sbindir}/upsmon
%{_sbindir}/upssched
%{_mandir}/man5/upsmon.conf.5*
%{_mandir}/man5/upssched.conf.5*
%{_mandir}/man8/nut-scanner.8*
%{_mandir}/man8/upsc.8*
%{_mandir}/man8/upscmd.8*
%{_mandir}/man8/upslog.8*
%{_mandir}/man8/upsmon.8*
%{_mandir}/man8/upsrw.8*
%{_mandir}/man8/upssched.8*

%pre
# Create an UPS user
%_pre_useradd %{nutuser} /var/state/ups /bin/false
%{_sbindir}/usermod -G dialout,tty,usb %{nutuser}

%preun
# only do this if it is not an upgrade
%systemd_preun nut-monitor

%post
%systemd_post nut-monitor

%postun
# Only do this if it is not an upgrade
if [ ! -f %_sbindir/upsd ]; then
   %_postun_userdel %{nutuser}
fi
%systemd_postun nut-monitor

#----------------------------------------------------------------------------

%package -n	%{libname}
Summary:	Network UPS Tools Client Utilities library
Group:		System/Libraries
Conflicts:	%{_lib}upsclient1 < 1:2.6.4-10

%description -n %{libname}
This package contains a shared libraries for NUT client applications.

%files -n %{libname}
%{_libdir}/libnutscan.so.%{major}*

#----------------------------------------------------------------------------

%package -n	%{libups}
Summary:	Network UPS Tools Client Utilities library
Group:		System/Libraries

%description -n %{libups}
This package contains a shared libraries for NUT client applications.

%files -n %{libups}
%{_libdir}/libupsclient.so.*


%package -n	%{libnut}
Summary:	Network UPS Tools Client Utilities library
Group:		System/Libraries

%files -n %{libnut}
%{_libdir}/libnutclient.so.*

#----------------------------------------------------------------------------

%package	server
Summary:	Network UPS Tools server
Group:		System/Servers
Requires:	nut = %{EVRD}
Requires(pre):	nut = %{EVRD}
Requires(pre):	rpm-helper
Requires:	tcp_wrappers
Requires(post):	systemd
Requires(postun): systemd
Requires(preun): systemd

%description	server
These programs are part of a developing project to monitor the assortment of
UPSes that are found out there in the field. Many models have serial ports of
some kind that allow some form of state checking. This capability has been
harnessed where possible to allow for safe shutdowns, live status tracking on
web pages, and more.

This package is the main NUT upsd daemon and the associated per-UPS-model
drivers which talk to the UPSes. You also need to install the base NUT package.

%files server
%{_unitdir}/nut-server.service
%{_unitdir}/nut-driver.service
%{_systemshutdowndir}/nutshutdown
%{_sbindir}/upsd
%attr(0644,%{nutuser},%{nutuser}) %config(noreplace) %{_sysconfdir}/ups/ups.conf
%attr(0640,root,%{nutuser}) %config(noreplace) %{_sysconfdir}/ups/upsd.users
%attr(0640,root,%{nutuser}) %config(noreplace) %{_sysconfdir}/ups/upsd.conf
%attr(0644,root,root) %{_sysconfdir}/udev/rules.d/70-nut-usbups.rules
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/hotplug/usb/libhid.usermap
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/hotplug/usb/libhidups
%{_sbindir}/apcsmart
%{_sbindir}/apcsmart-old
%{_sbindir}/bcmxcp
%{_sbindir}/bcmxcp_usb
%{_sbindir}/belkin
%{_sbindir}/belkinunv
%{_sbindir}/bestfcom
%{_sbindir}/bestfortress
%{_sbindir}/bestuferrups
%{_sbindir}/bestups
%{_sbindir}/blazer_ser
%{_sbindir}/blazer_usb
%{_sbindir}/clone
%{_sbindir}/clone-outlet
%{_sbindir}/dummy-ups
%{_sbindir}/etapro
%{_sbindir}/everups
%{_sbindir}/gamatronic
%{_sbindir}/genericups
%{_sbindir}/isbmex
%{_sbindir}/ivtscd
%{_sbindir}/liebert
%{_sbindir}/liebert-esp2
%{_sbindir}/masterguard
%{_sbindir}/metasys
%{_sbindir}/mge-shut
%{_sbindir}/mge-utalk
%{_sbindir}/microdowell
%{_sbindir}/oldmge-shut
%{_sbindir}/oneac
%{_sbindir}/optiups
%{_sbindir}/powercom
%{_sbindir}/powerman-pdu
%{_sbindir}/powerpanel
%{_sbindir}/rhino
%{_sbindir}/richcomm_usb
%{_sbindir}/safenet
%{_sbindir}/skel
%{_sbindir}/snmp-ups
%{_sbindir}/solis
%{_sbindir}/tripplite
%{_sbindir}/tripplitesu
%{_sbindir}/tripplite_usb
%{_sbindir}/upscode2
%{_sbindir}/upsdrvctl
%{_sbindir}/usbhid-ups
%{_sbindir}/victronups
%{_sbindir}/netxml-ups
%{_datadir}/cmdvartab
%{_datadir}/driver.list
%{_mandir}/man5/nut.conf.5*
%{_mandir}/man5/ups.conf.5*
%{_mandir}/man5/upsd.conf.5*
%{_mandir}/man5/upsd.users.5*
%{_mandir}/man8/apcsmart.8*
%{_mandir}/man8/apcsmart-old.8*
%{_mandir}/man8/bcmxcp.8*
%{_mandir}/man8/bcmxcp_usb.8*
%{_mandir}/man8/belkin.8*
%{_mandir}/man8/belkinunv.8*
%{_mandir}/man8/bestfcom.8*
%{_mandir}/man8/bestfortress.8*
%{_mandir}/man8/bestuferrups.8*
%{_mandir}/man8/bestups.8*
%{_mandir}/man8/clone.8*
%{_mandir}/man8/dummy-ups.8*
%{_mandir}/man8/etapro.8*
%{_mandir}/man8/everups.8*
%{_mandir}/man8/gamatronic.8*
%{_mandir}/man8/genericups.8*
%{_mandir}/man8/isbmex.8*
%{_mandir}/man8/ivtscd.8*
%{_mandir}/man8/liebert.8*
%{_mandir}/man8/liebert-esp2.8*
%{_mandir}/man8/masterguard.8*
%{_mandir}/man8/metasys.8*
%{_mandir}/man8/mge-shut.8*
%{_mandir}/man8/mge-utalk.8*
%{_mandir}/man8/microdowell.8*
%{_mandir}/man8/nutupsdrv.8*
%{_mandir}/man8/oneac.8*
%{_mandir}/man8/optiups.8*
%{_mandir}/man8/powercom.8*
%{_mandir}/man8/powerman-pdu.8*
%{_mandir}/man8/powerpanel.8*
%{_mandir}/man8/rhino.8*
%{_mandir}/man8/richcomm_usb.8*
%{_mandir}/man8/safenet.8*
%{_mandir}/man8/snmp-ups.8*
%{_mandir}/man8/solis.8*
%{_mandir}/man8/tripplite.8*
%{_mandir}/man8/tripplitesu.8*
%{_mandir}/man8/tripplite_usb.8*
%{_mandir}/man8/upscode2.8*
%{_mandir}/man8/upsd.8*
%{_mandir}/man8/upsdrvctl.8*
%{_mandir}/man8/usbhid-ups.8*
%{_mandir}/man8/victronups.8*
%{_mandir}/man8/netxml-ups.8*
%{_sbindir}/al175
%{_sbindir}/apcupsd-ups
%{_sbindir}/nutdrv_qx
%{_sbindir}/riello_ser
%{_sbindir}/riello_usb
%{_mandir}/man3/libnutclient.3*
%{_mandir}/man3/libnutclient_commands.3*
%{_mandir}/man3/libnutclient_devices.3*
%{_mandir}/man3/libnutclient_general.3*
%{_mandir}/man3/libnutclient_misc.3*
%{_mandir}/man3/libnutclient_tcp.3*
%{_mandir}/man3/libnutclient_variables.3*
%{_mandir}/man3/nutclient_authenticate.3*
%{_mandir}/man3/nutclient_destroy.3*
%{_mandir}/man3/nutclient_device_forced_shutdown.3*
%{_mandir}/man3/nutclient_device_login.3*
%{_mandir}/man3/nutclient_device_master.3*
%{_mandir}/man3/nutclient_execute_device_command.3*
%{_mandir}/man3/nutclient_get_device_command_description.3*
%{_mandir}/man3/nutclient_get_device_commands.3*
%{_mandir}/man3/nutclient_get_device_description.3*
%{_mandir}/man3/nutclient_get_device_num_logins.3*
%{_mandir}/man3/nutclient_get_device_rw_variables.3*
%{_mandir}/man3/nutclient_get_device_variable_description.3*
%{_mandir}/man3/nutclient_get_device_variable_values.3*
%{_mandir}/man3/nutclient_get_device_variables.3*
%{_mandir}/man3/nutclient_get_devices.3*
%{_mandir}/man3/nutclient_has_device.3*
%{_mandir}/man3/nutclient_has_device_command.3*
%{_mandir}/man3/nutclient_has_device_variable.3*
%{_mandir}/man3/nutclient_logout.3*
%{_mandir}/man3/nutclient_set_device_variable_value.3*
%{_mandir}/man3/nutclient_set_device_variable_values.3*
%{_mandir}/man3/nutclient_tcp_create_client.3*
%{_mandir}/man3/nutclient_tcp_disconnect.3*
%{_mandir}/man3/nutclient_tcp_get_timeout.3*
%{_mandir}/man3/nutclient_tcp_is_connected.3*
%{_mandir}/man3/nutclient_tcp_reconnect.3*
%{_mandir}/man3/nutclient_tcp_set_timeout.3*
%{_mandir}/man3/nutscan_get_serial_ports_list.3*
%{_mandir}/man3/nutscan_scan_eaton_serial.3*
%{_mandir}/man8/al175.8*
%{_mandir}/man8/apcupsd-ups.8*
%{_mandir}/man8/blazer_ser.8*
%{_mandir}/man8/blazer_usb.8*
%{_mandir}/man8/nutdrv_qx.8*
%{_mandir}/man8/riello_ser.8*
%{_mandir}/man8/riello_usb.8*

%pre	server
# Create an UPS user. We do not use the buggy macro %_pre_groupadd anymore.
%_pre_useradd %{nutuser} /var/state/ups /bin/false
%{_sbindir}/usermod -G dialout,tty,usb %{nutuser}

%preun	server
%systemd_preun nut-server

%post	server
%systemd_post nut-server

%postun	server
# Only do this if it is not an upgrade
if [ ! -f %{_sbindir}/upsmon ]; then
   %_postun_userdel %{nutuser}
fi
%systemd_postun nut-server

#----------------------------------------------------------------------------

%package	cgi
Summary:	CGI utils for NUT
Group:		Monitoring
Requires:	apache
Conflicts:	apcupsd

%description	cgi
These programs are part of a developing project to monitor the assortment of
UPSes that are found out there in the field. Many models have serial ports of
some kind that allow some form of state checking. This capability has been
harnessed where possible to allow for safe shutdowns, live status tracking on
web pages, and more.

This package adds the web CGI programs. These can be installed on a separate
machine to the rest of the NUT package.

%files cgi
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/ups/hosts.conf
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/ups/upsset.conf
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/ups/upsstats.html
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/ups/upsstats-single.html
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/httpd/conf/webapps.d/%{name}-cgi.conf
/var/www/cgi-bin/upsimage.cgi
/var/www/cgi-bin/upsset.cgi
/var/www/cgi-bin/upsstats.cgi
%dir %attr(0755,root,root) /var/www/nut
%attr(0644,root,root) /var/www/nut/bottom.html
%attr(0644,root,root) /var/www/nut/header.html
%attr(0644,root,root) /var/www/nut/index.html
%attr(0644,root,root) /var/www/nut/nut-banner.png
%{_mandir}/man5/hosts.conf.5*
%{_mandir}/man5/upsstats.html.5*
%{_mandir}/man5/upsset.conf.5*
%{_mandir}/man8/upsimage.cgi.8*
%{_mandir}/man8/upsset.cgi.8*
%{_mandir}/man8/upsstats.cgi.8*

#----------------------------------------------------------------------------

%package	devel
Summary:	Development for NUT Client
Group:		Development/C
Requires:	%{libname} = %{EVRD}
Requires:	%{libups} = %{EVRD}

%description	devel
These programs are part of a developing project to monitor the assortment of
UPSes that are found out there in the field. Many models have serial ports of
some kind that allow some form of state checking. This capability has been
harnessed where possible to allow for safe shutdowns, live status tracking on
web pages, and more.

This package contains the development header files and libraries
necessary to develop NUT client applications.

%files devel
%{_includedir}/*.h
%{_libdir}/*.so
%{_libdir}/pkgconfig/*.pc
%{_mandir}/man3/upscli_*.3*
%{_mandir}/man3/upsclient.3*
%{_mandir}/man3/nutscan_add_device_to_device.3*
%{_mandir}/man3/nutscan_add_option_to_device.3*
%{_mandir}/man3/nutscan_cidr_to_ip.3*
%{_mandir}/man3/nutscan_display_parsable.3*
%{_mandir}/man3/nutscan_display_ups_conf.3*
%{_mandir}/man3/nutscan_free_device.3*
%{_mandir}/man3/nutscan_new_device.3*
%{_mandir}/man3/nutscan_scan_avahi.3*
%{_mandir}/man3/nutscan_scan_ipmi.3*
%{_mandir}/man3/nutscan_scan_nut.3*
%{_mandir}/man3/nutscan_scan_snmp.3*
%{_mandir}/man3/nutscan_scan_usb.3*
%{_mandir}/man3/nutscan_scan_xml_http.3*
%{_mandir}/man3/nutscan.3*
%{_mandir}/man3/nutscan_init.3*

#----------------------------------------------------------------------------

%prep
%setup -q
%patch0 -p0 -b .upsset.conf
%patch1 -p1 -b .mdv_conf
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1

# instead of a patch
perl -pi -e "s|/cgi-bin/nut|/cgi-bin|g" data/html/*.html*

%build
# this takes care of rpath
#libtoolize --copy --force; aclocal -I m4; autoconf; automake --foreign --add-missing --copy
%serverbuild
autoreconf -vdi

%configure2_5x \
    --enable-static \
    --enable-shared \
    --sysconfdir=%{_sysconfdir}/ups \
    --with-systemdsystemunitdir=%{_unitdir} \
    --with-systemdsystemshutdowndir=%{_systemshutdowndir} \
    --with-serial \
    --with-usb \
    --with-snmp \
    --with-cgi \
    --with-dev \
    --with-ssl \
    --with-neon \
%if %{build_doc}
    --with-doc \
%endif
    --with-statepath=/var/state/ups \
    --with-drvpath=%{_sbindir} \
    --with-cgipath=/var/www/cgi-bin \
    --with-htmlpath=/var/www/nut \
    --with-pidpath=/var/run/nut \
    --with-port=3493 \
    --with-user=%{nutuser} \
    --with-group=%{nutuser} \
    --with-pkgconfig-dir=%{_libdir}/pkgconfig \
    --with-hotplug-dir=%{_sysconfdir}/hotplug \
    --with-udev-dir=%{_sysconfdir}/udev

%make

%install
%makeinstall_std

install -d %{buildroot}/var/state/ups
#install -d %{buildroot}/var/run/nut
install -m 0644 %{SOURCE103} -D %{buildroot}%{_prefix}/lib/tmpfiles.d/nut.conf

# move the *.sample config files to their real locations
# we don't need to worry about overwriting anything since
# they are marked as %config files within the package
for file in %{buildroot}%{_sysconfdir}/ups/*.sample
do
    mv $file %{buildroot}%{_sysconfdir}/ups/`basename $file .sample`
done

mv %{buildroot}%{_sysconfdir}/ups/upsmon.conf %{buildroot}%{_sysconfdir}/ups/upsmon.conf.sample
perl -pi -e 's/# RUN_AS_USER nutmon/RUN_AS_USER %{nutuser}/g' %{buildroot}%{_sysconfdir}/ups/upsmon.conf.sample
cp -a %{buildroot}%{_sysconfdir}/ups/upsmon.conf.sample %{buildroot}%{_sysconfdir}/ups/upsmon.conf
cp -af data/driver.list docs/

# udev usb ups stuff
mv %{buildroot}%{_sysconfdir}/udev/rules.d/52-nut-usbups.rules %{buildroot}%{_sysconfdir}/udev/rules.d/70-nut-usbups.rules
cp %{SOURCE102} %{buildroot}%{_sysconfdir}/udev/rules.d/70-nut-usbups.rules

# fix access config files
install -d %{buildroot}%{_sysconfdir}/httpd/conf/webapps.d
cat > %{buildroot}%{_sysconfdir}/httpd/conf/webapps.d/%{name}-cgi.conf << EOF

<Files upsset.cgi>
    Require all denied
    Require local granted
    ErrorDocument 403 "Access denied per %{_sysconfdir}/httpd/conf/webapps.d/%{name}-cgi.conf"
</Files>

Alias /nut /var/www/nut

<Directory "/var/www/nut">
    Require all denied
    Require local granted
    ErrorDocument 403 "Access denied per %{_sysconfdir}/httpd/conf/webapps.d/%{name}-cgi.conf"
</Directory>

EOF

# install missing (forgotten?) headers
install -m0644 tools/nut-scanner/*.h %{buildroot}%{_includedir}/

# cleanup
rm -f %{buildroot}%{_sysconfdir}/ups/nut.conf
rm -f %{buildroot}%{_libdir}/*.*a
rm -f %{buildroot}%{_mandir}/man8/nut-recorder.8*

cp %{SOURCE100} %{buildroot}%{_sysconfdir}/ups/ups.conf
cp %{SOURCE101} %{buildroot}%{_sysconfdir}/ups/upsd.users

%changelog
* Fri Jun 27 2014 Alex Burmashev <alex.burmashev@rosalab.ru> 1:2.7.1-5
+ Revision: 8465536
- MassBuild#440: Increase release tag


